#include <version.h>
#include <kernel.h>
#include <kdata.h>
#include <devmem.h>

int mem_read(uint8_t minor, uint8_t rawflag)
{
    uint16_t addr;

    minor; rawflag; // shut up compiler
    addr = 512*udata.u_offset.o_blkno+udata.u_offset.o_offset;

    // WRS: ? why is it a secret??
    if (addr < 0x006C)
        return (1);

    if (udata.u_sysio)
        memcpy(udata.u_base, (char *)addr, udata.u_count);
    else
        uput((char *)addr, udata.u_base, udata.u_count);

    return(udata.u_count);
}


int mem_write(uint8_t minor, uint8_t rawflag)
{
    uint16_t addr;

    minor; rawflag; // shut up compiler
    addr = 512*udata.u_offset.o_blkno+udata.u_offset.o_offset;

    // OK so I can see we don't want people overwriting our interrupt vectors...
    if (addr < 0x006C)
        return (1);

    if (udata.u_sysio)
        memcpy((char *)addr, udata.u_base, udata.u_count);
    else
        uget(udata.u_base, (char *)addr, udata.u_count);

    return(udata.u_count);
}
