#include <version.h>
#include <kernel.h>
#include <kdata.h>
#include <devproc.h>

int proc_read(uint8_t minor, uint8_t rawflag)
{
    uint16_t addr;

    minor; rawflag; // shut up compiler
    addr = (uint16_t) &ptab;
    addr += 512*udata.u_offset.o_blkno+udata.u_offset.o_offset;

    if (addr < (unsigned) ptab || addr >= (unsigned) (ptab + PTABSIZE))
        return (1);

    if (udata.u_sysio)
        memcpy(udata.u_base, (char *)addr, udata.u_count);
    else
        uput((char *)addr, udata.u_base, udata.u_count);

    return(udata.u_count);
}


int proc_write(uint8_t minor, uint8_t rawflag)
{
    minor; rawflag; // shut up compiler
    udata.u_error = EINVAL;
    return (-1);
}

#define PIO_TABSIZE	1
#define PIO_ENTRYSIZE	2

int proc_ioctl(uint8_t minor, uint16_t request, char *data)
{
    minor;
    switch (request) {
    case PIO_TABSIZE:
         uputw(maxproc, data);
         break;

    case PIO_ENTRYSIZE:
         uputw(sizeof(struct p_tab), data);
         break;

    default:
         udata.u_error = EINVAL;
         return (-1);
    }
    return 0;
}
