#ifndef __TIMER_DOT_H__
#define __TIMER_DOT_H__

#include <stdbool.h>
#include <kernel.h>

typedef uint16_t timer_t;

#define SYSTEM_TIMER_HZ  (50)
extern timer_t system_timer; /* counts up at SYSTEM_TIMER_HZ, wraps to zero */
timer_t set_timer_duration(uint16_t duration); /* good for up to approx 0x8000 ticks */
bool timer_expired(timer_t timer_val);

void addtick(uzitime_t *t1, uzitime_t *t2);
void incrtick (uzitime_t *t);
void rdtime (uzitime_t *tloc);

#endif
